/*  Name     : main.c
 *  Purpose  : Main file for 24LC64 EEPROM code for AT89C51.
 *  Author   : M.Saeed Yasin
 *  Date     : 05-11-12
 *  Website  : saeedsolutions.blogspot.com
 *  Revision : None
 */
#include <reg51.h>
#include "Includes.h"

unsigned char y;

void printHex(unsigned char hx);
void print4bits(unsigned char x);

// Main function
int i;

void main()
{	
	// Initialize LCD
	InitLCD();
	
	// Initialize i2c pins
	InitI2C();				

  Write_Byte_To_24LC64_EEPROM(10,0x50);// write 0x50 to address 10
	y=Read_Byte_From_24LC64_EEPROM(10);   //read it back
	
	WriteDataToLCD(y);     //print .. if printable
	WriteDataToLCD(' ');   //space
	
	//print  hex

   printHex(y);
		
		while(1){	}  //stop
		
}


void printHex(unsigned char hx)
{
   print4bits(hx >>4);  //print high 4 bits
	 print4bits(hx & 0x0f); //print low 4 bits
}
	

void print4bits(unsigned char x)
{
		if(x < 10)  //0-9 
			x+=0x30; //print as ascill 0x30 to 0x39 1-9
	else
		x+=55;  //print as ascill 0x41 to 0x46 A-F
	
		WriteDataToLCD(x);
}
	
